package es.bcn.gca.necn.business.model.bo.impl;

import java.util.List;

import net.opentrends.openframe.services.logging.LoggingService;
import net.opentrends.openframe.services.persistence.hibernate.HibernateDAO;
import es.bcn.gca.necn.common.model.EstatsVO;


public class EstatsBOImpl  implements es.bcn.gca.necn.common.model.bo.EstatsBO {
	HibernateDAO hibernateDao;

	/** Accs al servei de traces. */
	LoggingService logService;

	public HibernateDAO getHibernateDao() {
		return hibernateDao;
	}

	public void setHibernateDao(HibernateDAO hibernateDao) {
		this.hibernateDao = hibernateDao;
	}

	/** Default constructor. */	
	/**
	 * 
	 */
	public EstatsBOImpl() {
		super();
	}

	public void delete(EstatsVO estats) throws Exception {
		
		hibernateDao.delete(estats);
	}

	public List findAll() {
		return hibernateDao.findAll(EstatsVO.class);
	}

	public EstatsVO get(EstatsVO estats) {
		estats = (EstatsVO) hibernateDao.get(EstatsVO.class,
				estats.getEstatId());
		return estats;
	}

	public EstatsVO load(EstatsVO estats) {
		estats = (EstatsVO) hibernateDao.load(EstatsVO.class,
				estats.getEstatId());
		return estats;
	}

	public void save(EstatsVO estats) throws Exception {
		
		hibernateDao.save(estats);
	}

	public void saveOrUpdate(EstatsVO estats) throws Exception {
		
		hibernateDao.saveOrUpdate(estats);
	}

	public void update(EstatsVO estats) throws Exception {
		
		hibernateDao.update(estats);
	}

	public LoggingService getLogService() {
		return logService;
	}

	public void setLogService(LoggingService logService) {
		this.logService = logService;
	}
  
}
