package es.bcn.gca.necn.business.model.bo.impl;

import java.util.List;

import net.opentrends.openframe.services.logging.LoggingService;
import net.opentrends.openframe.services.persistence.hibernate.HibernateDAO;
import es.bcn.gca.necn.common.model.GrupsVO;


public class GrupsBOImpl  implements es.bcn.gca.necn.common.model.bo.GrupsBO {
	HibernateDAO hibernateDao;

	/** Accs al servei de traces. */
	LoggingService logService;

	public HibernateDAO getHibernateDao() {
		return hibernateDao;
	}

	public void setHibernateDao(HibernateDAO hibernateDao) {
		this.hibernateDao = hibernateDao;
	}

	/** Default constructor. */	
	/**
	 * 
	 */
	public GrupsBOImpl() {
		super();
	}

	public void delete(GrupsVO grups) throws Exception {
		
		hibernateDao.delete(grups);
	}

	public List findAll() {
		return hibernateDao.findAll(GrupsVO.class);
	}

	public GrupsVO get(GrupsVO grups) {
		grups = (GrupsVO) hibernateDao.get(GrupsVO.class,
				grups.getGrupId());
		return grups;
	}

	public GrupsVO load(GrupsVO grups) {
		grups = (GrupsVO) hibernateDao.load(GrupsVO.class,
				grups.getGrupId());
		return grups;
	}

	public void save(GrupsVO grups) throws Exception {
		
		hibernateDao.save(grups);
	}

	public void saveOrUpdate(GrupsVO grups) throws Exception {
		
		hibernateDao.saveOrUpdate(grups);
	}

	public void update(GrupsVO grups) throws Exception {
		
		hibernateDao.update(grups);
	}

	public LoggingService getLogService() {
		return logService;
	}

	public void setLogService(LoggingService logService) {
		this.logService = logService;
	}
  
}
