package es.bcn.gca.necn.web.pojo;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import es.bcn.gca.necn.common.model.PeticionsVO;


public class PaquetsTO  implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	
	private String paqId;

	private int paqVersio;

	private String paqDesc;

	private String paqEstat;

	private String paqContext;

	private Date paqDataCreacio;

	private Date paqDataModif;
	
	private String paqObservacions;
	
	private String paqGrup;

	private Set peticions = new HashSet(0);

	public PaquetsTO() {
	}

	public PaquetsTO(String paqId, int paqVersio, String paqDesc,
			String paqEstat, String paqContext, Date paqDataCreacio,
			Date paqDataModif) {
		this.paqId = paqId;
		this.paqVersio = paqVersio;
		this.paqDesc = paqDesc;
		this.paqEstat = paqEstat;
		this.paqContext = paqContext;
		this.paqDataCreacio = paqDataCreacio;
		this.paqDataModif = paqDataModif;
	}

	public PaquetsTO(String paqId, int paqVersio, String paqDesc,
			String paqEstat, String paqContext, Date paqDataCreacio,
			Date paqDataModif, String paqObservacions, String paqGrup,Set peticions) {
		this.paqId = paqId;
		this.paqVersio = paqVersio;
		this.paqDesc = paqDesc;
		this.paqEstat = paqEstat;
		this.paqContext = paqContext;
		this.paqDataCreacio = paqDataCreacio;
		this.paqDataModif = paqDataModif;
		this.paqObservacions = paqObservacions;
		this.paqGrup = paqGrup;
		this.peticions = peticions;
	}

	public String getPaqId() {
		return this.paqId;
	}

	public void setPaqId(String paqId) {
		this.paqId = paqId;
	}

	public int getPaqVersio() {
		return this.paqVersio;
	}

	public void setPaqVersio(int paqVersio) {
		this.paqVersio = paqVersio;
	}

	public String getPaqDesc() {
		return this.paqDesc;
	}

	public void setPaqDesc(String paqDesc) {
		this.paqDesc = paqDesc;
	}

	public String getPaqEstat() {
		return this.paqEstat;
	}

	public void setPaqEstat(String paqEstat) {
		this.paqEstat = paqEstat;
	}

	public String getPaqContext() {
		return this.paqContext;
	}

	public void setPaqContext(String paqContext) {
		this.paqContext = paqContext;
	}

	public Date getPaqDataCreacio() {
		return this.paqDataCreacio;
	}

	public void setPaqDataCreacio(Date paqDataCreacio) {
		this.paqDataCreacio = paqDataCreacio;
	}

	public Date getPaqDataModif() {
		return this.paqDataModif;
	}

	public void setPaqDataModif(Date paqDataModif) {
		this.paqDataModif = paqDataModif;
	}

	public String getPaqObservacions() {
		return this.paqObservacions;
	}

	public void setPaqObservacions(String paqObservacions) {
		this.paqObservacions = paqObservacions;
	}
	
	public String getPaqGrup() {
		return this.paqGrup;
	}

	public void setPaqGrup(String paqGrup) {
		this.paqGrup = paqGrup;
	}
	
	public Set getPeticions() {
		return this.peticions;
	}

	public void setPeticions(Set peticions) {
		this.peticions = peticions;
	}
	
	public void addToPeticio(PeticionsVO peticio) {
        this.getPeticions().add(peticio);
        peticio.getPaquets().add(this);
	}

	public void removeFromPaquet(PeticionsVO peticio) {
		this.getPeticions().remove(peticio);
        peticio.getPaquets().remove(this);
	}
}
