/*Per tal de no duplicar funcions, aquest js depen del js openFrame-ajaxtags-validation.js. */
var _pageTopScroll_ = 0;

/* Nom de l'element global del DOM . Es fa servir al fer un eval d'un codi javascript el qual t? una refer?ncia del this
 * que executa el codi.
 */
var sourceElemTab;

/* Referencia al form actiu.*/
var formTabActive;

/* Object de tipus Map que guarda les dades originals del form.*/
var dadesOrigDivActive;

function executeAfterLoadingTab(obj){
	
	eval('try{ afterLoadingTab()}catch(e){}');
}

function afterLoadingTab(){
	DivNoticeManager.setProcessing(false);
	setValueDadesOrigDivActive();
}

function executeAjaxTab(elem, url, params,contStyleId,curStyleId) {
  var myAjax = new AjaxJspTag.TabPanel(url, {
	parameters: params,
	currentStyleId: curStyleId,
	postFunction: executeAfterLoadingTab,
	target: contStyleId,
	source: elem
	});
}

/* =================================================================== */
/* ==    Funcions especfiques per a gestionar les subpestanyes     == */ 
/* =================================================================== */

/* 
 * Executa el codi de la pestanya activa de l'element elem. Per a executar el codi el que es fa es avaluar 
 * l'acci associada a l'atribut onclick de a pestanya.
 * @elem: Element del DOM que identifica el panel.
 * @idActiveTab: identificador del nom que t la pestanya activa.
 */
function executeOnClickActiveTab(elem,idActiveTab) {    
    var listLi = elem.getElementsByTagName("li");    
    var onClickCode = '';    
    
    for(var i = 0;i < listLi.length;i++){	
   		var elemLiChild = listLi[i];   		
   		if(elemLiChild.id == idActiveTab){   			
   			var activeTabAnchor = elemLiChild.getElementsByTagName("a")[0];   								
			onClickCode = activeTabAnchor.getAttribute('onclick');									
			window.sourceElemTab = activeTabAnchor;			
			break;
   		}   		
	}
		
	/* En el cas de IE, el codi que hi ha onClickCode es fica dintre d'una funci? anonymous, i per tant eval
	 * no executa ni avalua res.
	 */
	if (typeof onClickCode == 'function') {  		 	  
	  onClickCode();
	}else if(onClickCode != ''){
      eval(onClickCode); 
	}		 		       
}

/*
 * Aquesta funci s'encarrega de mostrar el panel de subpestanyes indicat pel parmetre idDivSubPestanyes
 * i mostrar el contingut de la primera subpestanya.
 * @sourceElem: Referencia a la pestanya pare de les subpestanyes.
 * @idDivSubPestanyes: Id del panell de subpestanyes a mostrar.
 * @idActiveSubTag: Id del identificador de pestanya activa.
 */
function showSubPanel(sourceElem, idDivSubPestanyes, idActiveSubTab){
	// El primer pas es ocultar tots els divs de subpestanyes que estiguin actius i deixar visible nomes
	// el que tingui per id idDivSubPestanyes.	
	 hideSubTagsDiv();
                    
     Element.show($(idDivSubPestanyes));
     
     // El seguent pas s deixar com a activa la pestanya pare de les subpestanyes.
     activarPestanya(sourceElem, idActiveSubTab);
          	     
     /* Ara hem de deixar la pestanya com activa i desactivar la resta.*/
     //activarPestanya($('tabPanel'), idActiveSubTab);
     
     // I per ltim, hem de carregar el contingut de la seva subpestanya activa.
     executeOnClickActiveTab($(idDivSubPestanyes),idActiveSubTab);          
}

/*
 * Funci que oculta tots els divs de subpestanyes.
 */
function hideSubTagsDiv(){	 	 	 
	 var subTabsDivs = window.divsSubTabArray;
	 for (var i = 0; i < subTabsDivs.length; i++) {
         Element.hide($(subTabsDivs[i]));
     }
}

/* =================================================================== */
/* == Fi de funcions especfiques per a gestionar les subpestanyes  == */
/* =================================================================== */

function doScrollTop(){
	document.documentElement.scrollTop = _pageTopScroll_;
}

/* 
 * Funci que s'encarrega de fer la crida i carregar el contingut d'una pestanya.
 * Els parmetres sn:
 * @sourceElem:  Element que ha executat la crida. Generalment un tag <a>. Es fa servir bsicament per a 
 *   modificar l'estil de la pestanya activa.
 * @ currentStyleId: Identificador del current style.
 * @ sourceDiv: Identificador del div al qual s'ha d'injectar el contingut.
 * @ url: URL ha executar per a recuperar dinmicament el contingut.
 * @ parameters: parmetres addicionals a afegir a la url. 
 * @ reloadTab: Flag que indica si el contingut del tab s'ha de recarregar del servidor en cas de que aquest ja estigui informar. 
 * 
 */
function toggleTabServer(sourceElem,currentStyleId,sourceDiv,url,parameters,reloadTab) {
		
	if(!sourceElem.tagName){		
		sourceElem = window.sourceElemTab;
	}	
	
	if($(sourceDiv).innerHTML=='' || reloadTab){
		//alert('buit');
		var myAjax = new AjaxJspTag.TabPanel(url, {
		parameters: parameters,	
		method: 'post', // Aquest s el valor per defecte al fer una petici, per s modificat per la funci setAjaxOptions...
		currentStyleId: currentStyleId,
		postFunction: executeAfterLoadingTab,
		target: sourceDiv,
		source: sourceElem,
		evalScripts: true
		});
		toggleTab(sourceElem,currentStyleId,sourceDiv,true);		
	}else{
		toggleTab(sourceElem,currentStyleId,sourceDiv);		
	}
	
	return;
}

/* 
 * Funci que s'encarrega d'ocultar el contingut de totes les pestanyes i deixar noms visible 
 * el contingut de la pestanya activa. Tamb s'encarrega de informar les variables globals
 * currentDivActive i currentStyleIdVar.
 * Els parmetres sn:
 * @ sourceElem:  Element que ha executat la crida. Generalment un tag <a>. Es fa servir bsicament per a 
 *   modificar l'estil de la pestanya activa.
 * @ currentStyleId: Identificador del current style.
 * @ sourceDiv: Identificador del div al qual s'ha d'injectar el contingut.
 * @ loadContent: Indica si el contingut de la pestanya es recupera via petici al servidor.
 * 
 */
function toggleTab(sourceElem,currentStyleId,sourceDiv,loadContent) {					
					
	var allDivs = window.divsTabArray;
	
	// Ocultem la secci d'errors.
	initErrorsZone();

	// Marquem com a div actiu el corresponent a sourceDiv, aix com el valor de l'estil actiu.
	currentDivActive = sourceDiv;
	currentStyleIdVar = currentStyleId;
	
	//Activem la pestanya amb id igual a sourceDiv, i ocultem la resta.
	for (var i = 0; i < allDivs.length; i++) {
          if (allDivs[i]==sourceDiv) {
             Element.show($(sourceDiv));
          }
          else {
             Element.hide($(allDivs[i]));
          }
    }        
		
	activarPestanya(sourceElem,currentStyleId);
	
	if(!loadContent){			
		//Per ltim, en el cas de que la pestanya tingui activat el flag dfw, emmagatzemem les dades originals que cont
		//per a la posterior validaci de canvis pendents de confirmar.
		setTimeout("setValueDadesOrigDivActive()",250);					
	}
	closeDialog();
	return;	
}

/*
 * Aquesta funcio s'encarrega de modificar l'estil de la pestanya activa de l'element
 * sourceElem, i modificar l'estil de la resta per tal de que es mostrin com no actives.
 * @ sourceElem:  Element que ha executat la crida. Generalment un tag <a>. Es fa servir bsicament per a 
 *   modificar l'estil de la pestanya activa.
 * @ currentStyleId: Identificador del current style.
 */
function activarPestanya(sourceElem,currentStyleId){
	// sourceElem correspon a un tag <a>, i el que fem es modificar el id
	// de tots els nodes del tag <ul>, que s?n tags <li>, a '', i despr?s assignem 
	// al id del node pare del tag <a> el valor que l'identifica com a pestanya
	// activa.
			
	var ulElement = sourceElem.parentNode.parentNode;
	
	//for(var i = 0;i < sourceElem.parentNode.parentNode.childNodes.length;i++){	
	for(var i = 0;i < ulElement.getElementsByTagName('li').length;i++){	
	   
	   //var liNode = sourceElem.parentNode.parentNode.childNodes[i]; 
	   var liNode = ulElement.getElementsByTagName('li')[i]; 
	   	   
	   // Assignem el valor de l'atribut id del tag <li> a ''.
	   // sourceElem.parentNode.parentNode.childNodes[i].id='';
	   liNode.id = '';
	   // Assignem el valor de l'atribut id del tag <a>, fill del <li>, a ''.
	   liNode.getElementsByTagName('a')[0].id = '';
	}
	sourceElem.id = currentStyleId;
	sourceElem.parentNode.id = currentStyleId; 
	
	//alert('sourceElem.parentNode:'+sourceElem.parentNode.tagName + '\n id:'+sourceElem.parentNode.id);
}

/*
 * Funci que s'executa al clickar sobre una pestanya. S'encarrega de gestionar la crida a les diferents funcions
 * que estan involucrades al accedir-hi a una pestanya.
 * @ sourceElem:  Element que ha executat la crida. Generalment un tag <a>. Es fa servir bsicament per a 
 *   modificar l'estil de la pestanya activa.
 * @ currentStyleId: Identificador del current style.
 * @ sourceDiv: Identificador del div al qual s'ha d'injectar el contingut de la pestanya.
 * @ url: URL ha executar per a recuperar dinmicament el contingut de la pestanya.
 * @ parameters: parmetres addicionals a afegir a la url. 
 * @ reloadTab: Flag que indica si el contingut del tab s'ha de recarregar del servidor en cas de que aquest ja estigui informat. 
 */
function changeActiveTab(sourceElem,currentStyleId,sourceDiv,url,parameters,reloadTab){
	
	if(!DivNoticeManager.isProcessing()){				
		//Primer, validem si la pestanya a la qual ens trobem s dfw i t canvis pendents de confirmar. 	
		if(validateDirtyForm()){		
			openInfoDialog(sourceElem, literaldivTabChanged);

			//Segon, si no estem navegant pel panell de subpestanyes, hem d'ocultar els divs corresponents a subpestanyes.
			var isSubTab = 	isSubPestanyaTab(sourceDiv);
			if(!isSubTab){
				hideSubTagsDiv();
			}

			// Tercer, ens asegurem que quan es faci la carrega del nou tab, no s'espatllin els objectes del tab
			// que del que estem sortint:
			blockOnLoadBehavioursOnTab(currentDivActive);

			//Per ltim, activem la nova pestanya activa. La funci a cridar depen de si el parmetre url est informat o no.
			if(!isNull(url) && url.length>0){
				toggleTabServer(sourceElem,currentStyleId,sourceDiv,url,parameters,reloadTab);
			}else{
				toggleTabServer(sourceElem,currentStyleId,sourceDiv);
			}
		}	
	}
	return false;
}

/*
 * Funcio que permet configurar els objectes d'un tab de manera que si es torna a fer un page.onLoad
 * (la qual cosa tindra lloc cada vegada que s'entri en un tab amb reloadTab = true), res s'espatlli:
 */
function blockOnLoadBehavioursOnTab(tabDiv){
	var divObject = $(tabDiv);

	if(divObject){
		// En el cas de TextAreas riques de TinyMCE, bloquejarem l'aplicacio de nous behaviours aprofitant
		// el mecanisme de editor_deselector que fa servir TinyMCE durant el onLoad d'una pagina:
		if(typeof tinyMCE != 'undefined'){
			if(tinyMCE){
				var textAreasList = divObject.getElementsByTagName('textarea');
				if(textAreasList){
					for (i=0;i<textAreasList.length;i++){
						var textArea = textAreasList[i];
						var newTextAreaClass = 'mceNoEditor'; // Valor defecte de editor_deselector en TinyMCE
						if (textArea.className) {
							if (textArea.className.indexOf(newTextAreaClass) != -1) {
								newTextAreaClass = textArea.className;
							} else {
								newTextAreaClass = textArea.className + ' ' + newTextAreaClass;
							}
						}
						textArea.className = newTextAreaClass;
					}
				}		
			}
		}

		// Altres casos especials anirian aqui...
	}
}

/*
 * Retorna true/false en funci de si el div sourceDiv correspon al contingut d'una pestanya
 * amb dirtyFormWarning activat.
 * @ sourceDiv Identificador del div associat al contingut d'una pestanya.
 */
function isDirtyFormWarningTab(sourceDiv){
	
    var divs = window.divsDfwTabArray;
    var isDfwTab = false;
			
	// Validem si la pestanya corresponent a sourceDiv forma part de la llista de pestanyes amb dfw activat.
	for (var i = 0; i < divs.length; i++) {
          if (divs[i]==sourceDiv) {
            isDfwTab = true;
            break;
          }                 
    }  
	
	return isDfwTab;
	
}

/*
 * Retorna true/false en funci de si el div sourceDiv correspon al contingut d'una subpestanya.
 * @ sourceDiv Identificador del div associat al contingut d'una pestanya.
 */
function isSubPestanyaTab(sourceDiv){
	
	var divs = window.divsSubTabArray;
    var isSubTab = false;
			
	// Validem si la pestanya corresponent a sourceDiv forma part de la llista de subpestanyes.
	for (var i = 0; i < divs.length; i++) {
          if (divs[i]==sourceDiv) {
        	  isSubTab = true;
            break;
          }                 
    }  
	
	return isSubTab;
}

/*
 * Fixa el valor de la variable global dadesOrigDivActive. En cas de que la pestanya associada al div
 * currentDivActive tingui el flag dfw activat, el bean emmagatzema el contingut dels forms del div.
 * En cas contrari, es deixa a null.
 */
function setValueDadesOrigDivActive(){
	if(isDirtyFormWarningTab(currentDivActive)){
		dadesOrigDivActive = getBeanWithDivContent(currentDivActive);
	}else{
		dadesOrigDivActive = null;
	}
	return;
}

/*
*Aquesta funci retorna un bean amb les dades contingudes al div amb id igual a divId.
*Les dades que es recuperen del div sn totes aquelles que estiguin dintre d'un form. A ms, per a contemplar el cas d'un div
*amb ms d'un formulari, el nom de cada element del bean t un prefix que identifica a que formulari correspon.
*@ divId: Identificador del bean del qual es volen recuperar les dades.
*/
function getBeanWithDivContent(divId){
	var divObject = $(divId);
	var divBean = new Object();
	
	if(divObject){		
		//Recuperem la llista de formularis interns al div.
		var formsList = divObject.getElementsByTagName("form");
		if(formsList){
			for (i=0;i<formsList.length;i++){
				var formDiv = formsList[i];
				var divFormBean = getBeanForm(formDiv);
				var formDivName = formDiv.name.value;	
				//Les dades del bean associat al form les afegim al bean del div.
				putDades(divBean,divFormBean,formDivName+"_");	
			}
		}		
	}		
	return divBean;
}

/*
*Afegeix el contingut de mapOrig en mapDesti, afegint al nom de cada element de mapOrig el prefix passat per
*parmetre.
*@mapDesti: map a on s'han de cpiar els valors.
*@mapOrig: map de la qual s'han de cpiar les dades.
*@prefix: prefix a afegir a les dades.
*/
function putDades(mapDesti,mapOrig, prefix){
	for (var property in mapOrig) {
	  mapDesti[prefix+property] = mapOrig[property];	       
  }
}

/*
*Retorna un bean amb les dades de tots els elements del form formObject.
*@formObject: formulari del qual es volen recuperar el bean.
*/
function getBeanForm(formObject){
	var divFormBean = new Object();
	// Obtain all components in form
	if (formObject) {		
		var list = formObject.elements;
		if (list){			
			for (i=0;i<list.length;i++){	  		  	
				var element = list[i]; 						
				if (element.name) { 						   							
					divFormBean[element.name] = '""';
				}				  		
			}
		}
	}
	
	getValuesFormName(formObject,divFormBean);	
	return divFormBean;
}


/*
 * Aquesta funci s'encarrega de validar, abans de canviar de pestanya, si el contingut de la pestanya  
 * activa s'ha modificat i no s'ha guardat.
 */
function validateDirtyForm(){				
	//Validem si la pestanya actualment activa correspon a una pestanya dfw
	if(isDirtyFormWarningTab(currentDivActive)){	
		//Si s dfw, ara validem si tenim les seves dades originals i les comparem amb les dades actuals.
		if(dadesOrigDivActive){
			var dadesActualsDiv = getBeanWithDivContent(currentDivActive);
			var normalFieldsAreEquals = (dadesOrigDivActive.compare(dadesActualsDiv));
			var specialFieldsAreEquals = validateDirtySpecialFields(currentDivActive);
			var areEquals = normalFieldsAreEquals & specialFieldsAreEquals;
			if(!areEquals){
				return confirm(literaldivContentChanged);
			}else{
				return areEquals;
			}
		}	
	}	
	
	return true;		
 }

/*
 * Aquesta funci valida si algun camp especial ha canviat (hi ha camps que es manegan fora del formulari,
 * i el mecanisme estandard per a obtenir el seus valors no serveix.
 * Torna true si cap camp ha canviat.
 */
function validateDirtySpecialFields(divId){
	var areEquals = true;
	var divObject = $(divId);

	if(divObject){
		// Cas de TextAreas riques de TinyMCE, que mantenen el seu contingut en iFrames:
		if(typeof tinyMCE != 'undefined'){
			if(tinyMCE){
				//Recuperem la llista de iFrames interns al DIV:
				var iFramesList = divObject.getElementsByTagName('iframe');
				if(iFramesList){
					for (i=0;i<iFramesList.length;i++){
						var iFrame = iFramesList[i];
						// No tot iFrame te per que ser de TinyMCE, per aixo fem ho seguent amb cura:
						try {
							var isNotDirty = !tinyMCE.instances[iFrame.id].isDirty();
							areEquals = areEquals & isNotDirty;
						} catch(err) {
							// Res a fer, nomes ignorar l'error
						}
					}
				}		
			}
		}

		// Altres casos especials anirian aqui...
	}

	return areEquals;
}

 /* ====================================================================== */
 /* == Funcions especfiques per a gestionar la renderitzaci d'un      == */
 /* == llistat dintre de pestanyes.                                      == */
 /* ======================================================================*/
 
 function renderListIntoTab(sourceElem, url, divName){
	 loadTabContent(sourceElem, url, divName);
 }
 
 function loadTabContent(sourceElem, url, divName){
	 if(!divName){
		 divName = currentDivActive;
	 }	 
	 var divObject = $(divName);
	 
	 initErrorsZone();
	 
	 if(divObject){
		 divObject.innerHTML = "";
		 var myAjax = new AjaxJspTag.TabPanel(url, {
		 parameters: '',	
		 method: 'get', 		 		 
		 target: divObject,
		 source: sourceElem,
		 evalScripts: true
		 });
	 }	
 }
 
 /* ====================================================================== */
 /* == Funcions especfiques per a gestionar la validaci i l'enviament == */
 /* == de dades d'un formulari                                          == */
 /* ======================================================================*/ 
 
 function sendForm(oForm){ 	 				
	DWREngine.setErrorHandler(tabErrorHandling);
	
	if(oForm){ 	      		
 		if(!DivNoticeManager.isProcessing('submit')){
			DivNoticeManager.setProcessing(true,'submit');
		    if(DivNoticeManager.isProcessing()){
				updateInfoDialog(oForm, literaldivPersisting);
			}else{
				openInfoDialog(oForm, literaldivPersisting,true);
			}			
			var sParams = buildParameterList(oForm);
	 		var sActionForm = oForm.action;
	 		//var sUrl = sActionForm + '?' + sParams; 		
	 		var sUrl = sActionForm;
	 		changeContentTab(sUrl,oForm, sParams);
		}
 		return false;
 	}else{
 		alert('oForm no trobat');
 	} 
 } 

 function getRequestBody(oForm) {
		var aParams = new Array();
		for (var i=0 ; i < oForm.elements.length; i++) {
			var sParam = encodeURIComponent(oForm.elements[i].name);
			sParam += "=";
			sParam += encodeURIComponent(oForm.elements[i].value);
			aParams.push(sParam);
		}
		return aParams.join("&");
 }
 
 /*
  * Funci que s'encarrega d'actualitzar el contingut d'una pestanya.
  * Aquesta funci es crida al fer un submit del seu contingut. Un cop persistit els
  * canvis s'ha de recarregar el valor de la variable global dadesOrigDivActive.
  */
 function changeContentTab(url,sourceElem,parametres) {			
	   initErrorsZone();
	   var myAjax = new AjaxJspTag.TabPanel(url, {
			parameters: parametres,
			method: 'post',			
			postFunction: callbackChangeContentTab,
			currentStyleId: window.currentStyleIdVar,
			target: window.currentDivActive,
			source: sourceElem,
			timeout:5000,
			timeoutHandler: openErrorDialog
		});
}

/*
* Funci callback que es crida al carregar el contingut d'una pestanya.
*/
function callbackChangeContentTab() {
	closeDialog();
	setValueDadesOrigDivActive();		
}
 
 /*
  * Funci auxiliar que construeix la llista de parametres.
  */
 function buildParameterList(oForm) {
 	var aParams = new Array();
 	
 	for (var i=0 ; i < oForm.elements.length; i++) {
 		var field = oForm.elements[i];
 		if (field.type == 'select-multiple' && field.multiple) {
 			for (var j=0; j<field.options.length; j++) {
 				var elementValid = field.options[j].selected;
 				
 				if (elementValid){
 					var sParam = encodeURIComponent(field.name);
 					sParam += "=";
 					sParam += myEncodeURIComponent(field.options[j].value);
 					
 					aParams.push(sParam);
 				}
 			}
 		} else {
 			var elementValid = true;
 			if ((field.type =='checkbox' || field.type =='radio') && !field.checked) {
 				elementValid = false; 	      
 			} else {
 				elementValid = true;
 			}
 			
 			if (elementValid){
 				var sParam = encodeURIComponent(field.name);
 				sParam += "=";
 				sParam += myEncodeURIComponent(field.value);
 				
 				aParams.push(sParam);
 			}
 		}
 	} 	 	
 	return aParams.join(",");
 }

 _hexchars = "0123456789ABCDEF";
 _okURIchars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-";

 function _toHex(n) {
 	return _hexchars.charAt(n >> 4) + _hexchars.charAt(n & 0xF);
 }

 function myEncodeURIComponent(s)  {
 
	// For Mozilla and Safari standard encodeURIComponent
	if(Prototype.Browser.Mozilla || Prototype.Browser.Safari){
		return encodeURIComponent(s);
	} else {
		var c;
		var enc = "";
		if(s){
			for (var i= 0; i<s.length; i++) {
				if (_okURIchars.indexOf(s.charAt(i)) == -1) {
					enc += "%" + _toHex(s.charCodeAt(i));
				} else {
					enc += s.charAt(i);
				}
			}
		}
		return enc;
	}
 }
    
  
 
 function validateForm(oForm, pSource, pValidatorName, pClassName,doAjaxSubmitRequest){		
	
	if(!DivNoticeManager.isProcessing()){
	    //oForm.saveActionImage.disabled = true;
		var myValidator = new OpenFrameFormTab.ServerValidation({
			source: pSource,
			validatorName: pValidatorName,
			className: pClassName
		});		
		// Porque no llamar a validateTabForm desde el mismo initialize del objeto?
		myValidator.validateTabForm(oForm,pValidatorName,pClassName,doAjaxSubmitRequest);		
	}
 }

 function submitForm(oForm,doAjaxSubmitRequest){
	 if(doAjaxSubmitRequest) 
		 sendForm(oForm);
	 else{
		 oForm.innerContentTab.value=false;
		 oForm.submit();
	 }
 }
 
 /* ================================================================================ */
 /* == Code to validate on server the tab content.                                == */ 
 /* == Difference with a normal call to validation on server is at the callback   == */
 /* == function. At this case, if no errors found on validation, sendForm must    == */   
 /* == be call.                                                                   == */
 /* ================================================================================ */
 
 var OpenFrameFormTab = {
	 Version: '1.0'
 } 

 function tabErrorHandling(error){
	DivNoticeManager.setProcessing(false);
	window.alert("Error sending request to server" + error);
 }

		 
 /**
 * Extension of Ajax tag Base
 */
 OpenFrameFormTab.Base = function() {};
 OpenFrameFormTab.Base.prototype = (new AjaxJspTag.Base()).extend({});
 
 OpenFrameFormTab.ServerValidation = Class.create();
 OpenFrameFormTab.ServerValidation.prototype=(new AjaxJspTag.Base()).extend({

   initialize: function(options) {    
     this.setOptions(options);
     this.attachBehaviors(this.options.sourceElem, this.options.eventType, this.actionElemClicked, this);
   },


   // Create bean with values to send to validation service
   validateTabForm: function(sourceForm,validatorName,className,doAjaxSubmitRequest) {
        	   
 	   formTabActive = sourceForm;
	   //alert("validateTabForm");
	   //Element.hide($('errorsZone'));	
	   initErrorsZone();
 	   // mirem que el bot s'hagi de validar o no, depenent de si te la variable bCancel posada al onclick
 	   if (!bCancel){ 		  
		   openInfoDialog(sourceForm, literaldivValidating,true);
		  //alert("validateForm");
 		   DWREngine.setErrorHandler(tabErrorHandling);
 		     		  
           // Forcem el pas de iFrame a camp dels TextArea rics de TinyMCE (si es que hi ha algu):
           try {
              if (tinyMCE){
                 tinyMCE.triggerSave()
              }
           } catch(err) {
              // Res a fer, nomes ignorar l'error
           }

 		    // Obtain all components in form
 		  	if (sourceForm) {
 		  		// form expected
 		  		list = sourceForm.elements;				
 		  		 
 		  		if (list){
 	  		  		bean = new Object();
 	  		  		j=0;
 					for (i=0;i<list.length;i++){	  		  	
 						var element = list[i]; 						
 						if (element.name) { 						   							
 							bean[element.name] = '""';
 					    }				  		
 					}
 				}
 		  	}
 		  	// No podem fer la crida a getValuesName, ja que el que fa aquesta crida es recorrer el DOM
 		  	// per cercar els elements amb el nom indicat, i per a cada element s queda amb la primera aparcici.
 		  	// Aix, en el cas de que tinguem una pgina amb ms d'un formulari, i a on els formularis
 		  	// tinguin camps amb el mateix nom, donaria el problema de que sempre s'estarien agafant els
 		  	// valors del primer formulari.
 			//DWRUtil.getValuesName(bean);
 			getValuesFormName(sourceForm,bean);
 			 			 			 		   		  
 		    var dataFromBrowser = new Object();
 			dataFromBrowser['sourceForm'] = sourceForm;
 			dataFromBrowser['doAjaxSubmitRequest']=doAjaxSubmitRequest;
			 			 			 			 	
	        webValidationService.getWebValidationResults(className,validatorName,bean,
		 	{
		 		callback:function(dataFromServer) {		 		   
		 		   callbackValidateTabForm(dataFromServer,dataFromBrowser);
		 		},
				timeout:5000,
				timeoutHandler: openErrorDialog
	 	   });
 		     
 		       
 		    //} 
 		    
 		    return false;
 		} else {
			//sourceForm.saveActionImage.disabled = false; //Per a que feia falta aquest codi??? No sembla que tingui sentit abilitar un bot amb id saveActionImage
			// si es tracta d'un bot de tipus cancel fem submit sense validar
 			submitForm(sourceForm,doAjaxSubmitRequest);
 			return false;
 		}
   },

   actionElemClicked: function(e) {  
      
 	  // DWR calling
      //this.validateForm(this.options.sourceElem,this.options.validatorName)
	   
	   //this.validateTabForm(this.options.sourceElem,this.options.validatorName,this.options.className);   
	   Event.stop(e);    	   
   },
   	
   setOptions: function(options) {

     this.options = {
       sourceElem: $(options.source),
       validatorName: $(options.validatorName),
       //nous atributs validacio
       className: options.className       
       //eventType: options.eventType ? options.eventType : "submit"      
     }.extend(options || {});
   }
 });
 
 
/*
  *  Funci que s'encarrega d'inicialitzar la secci de la pgina corresponent als errors.
  * El que f s:
  *   - Eliminar tots els errors que hi puguin existir a la secci.
  *  - Ocultar el div de la secci d'errors de validaci.
  *  - Ocultar el div de la secci d'errors de servidor.
  */  
 function initErrorsZone(){
	 DWRUtil.removeAllOptions('errorList');
	 	 
	 if($('errorsZone'))
		Element.hide($('errorsZone'));	
	 if($('serverErrorsZone'))	
		Element.hide($('serverErrorsZone'));	 	  
	 if($('errorDetails_warning'))
		 Element.hide($('errorDetails_warning'));			 
	 if($('errorDetails_error'))
		 Element.hide($('errorDetails_error'));	 
	 if($('stackTrace'))
		Element.hide($('stackTrace'));		 
		 
		 		 	 
	 initErrorZone("globalErrorMsg");		 
	 initErrorZone("errorDetails_warning");
	 initErrorZone("errorDetails_error");
	 initErrorZone("stackTrace");	 	 
 }
 
 function initErrorZone(divId){
	 var errorDiv = $(divId);
	 if(errorDiv){
		 errorDiv.innerHTML="";
	 }	 
 }
 /*
  * Adaptaci del mtodo getValuesName de DWRUtils per tal de que donada una map
  * amb nom d'elements d'un formulari, recuperi el valor d'aquests. Per tal de poder
  * fer la recuperaci b, rep tamb per parmetre el formulari.
  * @oForm Formulari en el qual fer la verca dels valors.
  * @map Map a on cada entrada correspon al nom d'un element del formulari oForm. 
  */
 function getValuesFormName(oForm,map){
	 for (var i=0 ; i < oForm.elements.length; i++) {
	 		var field = oForm.elements[i];
	 		if (field.type == 'select-multiple' && field.multiple) {
	 			for (var j=0; j<field.options.length; j++) {
	 				var elementValid = field.options[j].selected;	 				
	 				if (elementValid && map[field.name]){	 					
	 					//map[field.name] = myEncodeURIComponent(field.options[j].value);	 						 					
						map[field.name] = field.options[j].value;	 						 					
	 				}
	 			}
	 		} else {
	 			var elementValid = true;
	 			if ((field.type =='checkbox' || field.type =='radio') && !field.checked) {
	 				elementValid = false; 	      
	 			} else {
	 				elementValid = true;
	 			}
	 			
	 			if (elementValid){	 				
	 				//map[field.name] = myEncodeURIComponent(field.value);	 				
					map[field.name] = field.value;	 				
	 			}
	 		}
	 } 
 }

 //function callbackValidateForm(dataFromServer,dataFromBrowser,valMessageMode,valMsgFunction,errorPanelStyleId) {
 function callbackValidateTabForm(dataFromServer,dataFromBrowser) {
			    				
	    // Obtain sourceForm of previous call to callback
	    var sourceForm = $(dataFromBrowser['sourceForm']);
	    var doAjaxSubmitRequest = dataFromBrowser['doAjaxSubmitRequest'];
		
					    	    	  
		var errors = dataFromServer;
	    	  
	    //DWRUtil.removeAllOptions('errorList');
	  	
		if (eval(errors.errorCount)>0) {
			closeDialog();
			
			validated = false;
		    DWRUtil.setValue('errorCount',errors.errorCount);
			i=0;
				       
	        Element.show($('errorsZone'));		    	
		    
		    for (i=0;i<eval(errors.errorCount);i++) {
		    
				error = errors.allErrors[i];
				// Message to show to each error
				defaultMessage = error.defaultMessage;
				fieldName = error.field;						
				
				fieldNameError = fieldName + "Error";
				
				// Process how to show field names
				processReply(false, fieldName, fieldNameError, defaultMessage);	
				
				// Show errors in errorList div
				errorRow = "<a href='javascript:void(0)' onclick=\" setFocusOnTab('" + fieldName + "')\" >" + defaultMessage + "</a>";
				DWRUtil.addOptions('errorList',[errorRow]);	
			}								
		}else {
			// Do a submit 
			if(sourceForm && !doAjaxSubmitRequest){
				closeDialog();
				submitForm(sourceForm,doAjaxSubmitRequest);				
			}
			else if (sourceForm) {								
				DivNoticeManager.setProcessing(false,'validation');
				closeDialog();
				eval("setTimeout(\"sendForm(formTabActive)\",250)");
			}
		
		}
	}
 
  /*
   * Funci que sobreescriu el comportament del corresponent setFocus d'ajaxtags.
   * La diferncia principal s que aquest mtode permet fixar el focus en un element
   * d'un formulari especfic ()el formulari formTabActive). Aix s til en el cas de que tingem una pgina
   * amb ms d'un formulari, i volguem fixar el focus en un camp de nom X, i ms
   * d'un formulari tingui un camp amb nom X. El comportament del setFocus de ajaxtags
   * donaria el focus a l'element X del primer formulari.   
   * @oFieldName Nom de l'element al qual volem donar el focus.
   */
  function setFocusOnTab(oFieldName) {
		if(formTabActive){	 
			for (var i=0 ; i < formTabActive.elements.length; i++){
				var field = formTabActive.elements[i];
				if(field.name == oFieldName){
					field.focus();
					break;
				}				
			}
		}	
	}

/* ================================================================================= */
/* ==  					Notice control methods						  == */
 /* ================================================================================ */
function openInfoDialog(sourceElem, message, disabledElements) { 
    DivNoticeManager.showNotice("info",message);
	if(disabledElements){
		DivNoticeManager.targetForm = sourceElem;
		DivNoticeManager.disableElements();
	}		
}

function updateInfoDialog(sourceElem, message) { 
    DivNoticeManager.updateNotice(message);
} 
  
function openErrorDialog() { 
	DivNoticeManager.showError("error",literaldivTimeoutError);	
    setTimeout(closeDialog,5000);		
}

function closeDialog(){	
	DivNoticeManager.setProcessing(false);
	DivNoticeManager.unnotify();
}