var bean;
var validated = false;
if (bCancel == undefined) var bCancel = false;


var OpenFrameFormTag = {
  Version: '1.0'
}

//
Hashtable.prototype.hash = null;
Hashtable.prototype.keys = null;
Hashtable.prototype.location = null;

function Hashtable(){
    this.hash = new Array();
    this.keys = new Array();

    this.location = 0;
}
Hashtable.prototype.get = function (key){
    return this.hash[key];
}
    
Hashtable.prototype.put = function (key, value){
    if (value == null)
        return null;

    if (this.hash[key] == null)
        this.keys[this.keys.length] = key;

    this.hash[key] = value;
}
Hashtable.prototype.length = function (){
    return this.keys.length;
}

/**
 * Prototype of String to add upper case of first letter of each word
 */
String.prototype.toProperCase = function(){
  return this.replace(/\w+/g,function(s){
    return s.charAt(0).toUpperCase() + s.substr(1);
  })
}

/**
 * Extension of Ajax tag Base
 */
 
OpenFrameFormTag.Base = function() {};
OpenFrameFormTag.Base.prototype = (new AjaxJspTag.Base()).extend({
});



/******************************************************************************
 * openFrame Validation behaviour
 ******************************************************************************/
 // openTrends 14/02/2008 -> canvi de forma d'agafar els elements, ara es fa per id, no per nom
function setFocus(objectname) {
    elements = document.getElementsByName(objectname);
    if (elements.length >= 1) {
      ele = elements.item(0);
      document.getElementById(ele.id).focus();
    }
}

function errorHandling(error){
    window.alert("Error sending request to server" + error);
}


function callbackValidateForm(dataFromServer,dataFromBrowser) {    
    // Obtain sourceForm of previous call to callback
    var sourceForm = $(dataFromBrowser['sourceForm']);
        
    var errors = dataFromServer;    
  
    DWRUtil.removeAllOptions('errorList');
    cleanErrors("openFrame_validation_error");
      
    if (eval(errors.errorCount)>0) {
        validated = false;
        DWRUtil.setValue('errorCount',errors.errorCount);
        i=0;        
        Element.show($('errorsZone'));
        Element.scrollTo($('errorsZone'));
        var fieldsProcessed = new Array();
        for (i=0;i<eval(errors.errorCount);i++) {
            error = errors.allErrors[i];
            // Message to show to each error
            defaultMessage = error.defaultMessage;
            fieldName = error.field;

            //ens assegurem que no haguem pintat marcat el camp ja
            if (!contains(fieldsProcessed, fieldName)) {
	            // Process how to show field names
	            processReply(fieldName, defaultMessage, "openFrame_validation_error");
	            fieldsProcessed[fieldsProcessed.length] = fieldName;
            }
            
            // Show errors in errorList div
            
            errorRow = "<a href='javascript:void(0)' onclick=\" setFocus('" + fieldName + "')\" >" + defaultMessage + "</a>";
            DWRUtil.addOptions('errorList',[errorRow]);    
        }    
                            
    } else {
        // Do a submit 
        if (sourceForm) {
            // Set validated to true in order to bypass validation and do submit without checkings
            validated = true;
            //alert("Submit form");
            sourceForm.submit();
        }
    
    }
}
function contains(a, obj) {
	  for(var i = 0; i < a.length; i++) {
	    if(a[i] === obj){
	      return true;
	    }
	  }
	  return false;
	}

function cleanErrors(styleClass) {
    var tags = document.getElementsByTagName("*");
    for (var i = 0; i < tags.length; i++) {
        removeClass(tags[i], styleClass);
        if (tags[i].className == "validation_error") {
        	tags[i].parentNode.removeChild(tags[i]);
        }
    }
}
 
/**
 * 
 * @param fieldName
 * @param error
 * @param styleClass
 * @return
 */
function processReply(fieldName, error, styleClass) {

	var fields = document.getElementsByName(fieldName);
	
	for (var i=0; i<fields.length; i++) {
		var fieldId = fields[i].id;
		if (fieldId) {
		    var fieldIdError = fieldId + "Error";
		    var label = $(fieldId + 'L');
		    var field = $(fieldId);
		    
		    var errDesc = $(fieldIdError);
		    if (label) {
		        putClass(label, styleClass);
		    }
		    if (field) {
		        putClass(field, styleClass);
		        var validationError = document.createElement("div");
		        validationError.className = "validation_error";
		        insertAfter(validationError, field);
		    }
		    if (errDesc) {
		        DWRUtil.setValue(errid, error);
		    }
		}
	}
}
//create function, it expects 2 values.
function insertAfter(newElement,targetElement) {
    //target is what you want it to go after. Look for this elements parent.
    var parent = targetElement.parentNode;
    //if the parents lastchild is the targetElement...
    if(parent.lastchild == targetElement) {
        //add the newElement after the target element.
        parent.appendChild(newElement);
    } else {
        // else the target has siblings, insert the new element between the target and it's next sibling.
        parent.insertBefore(newElement, targetElement.nextSibling);
    }
}

function putClass(element, styleClass) {
    if (!element.className || element.className.length == 0) {
        element.className = styleClass;
    } else {
        element.className = styleClass + " " + element.className;
    }
}
function removeClass(element, styleClass) {
    if (element.className && element.className.length >= styleClass.length) {
        if (element.className.substring(0, styleClass.length) == styleClass) {
        	element.className = element.className.substring(styleClass.length).trim();
        	removeClass(element, styleClass);
        }
    }
}

function validateFormDynamic(form) {
    
}
 
/******************************************************************************
 * Code to validate on client
 ******************************************************************************/
OpenFrameFormTag.ClientValidation = Class.create();
OpenFrameFormTag.ClientValidation.prototype=(new AjaxJspTag.Base()).extend({

  initialize: function(options) {    
    this.setOptions(options);
    this.attachBehaviors(this.options.sourceElem, this.options.eventType, this.actionElem, this);
  },

  actionElem: function(e) {  
     // Generate return validateValidatorName()
      // Example: return validateAccount(this)
      
      var javascriptFunction;
      var functionName = "validate" + this.options.validatorName.toProperCase();
      //var form = $(this.options.sourceElem);
      //var formName = form.name;
    //javascriptFunction = functionName + "($('" + formName + "'));";      
    javascriptFunction = functionName + "($('" + this.options.sourceName + "'));";
      var submitValidated = eval(javascriptFunction);
      if (!submitValidated)
          Event.stop(e);
  },
      
   setOptions: function(options) {
    this.options = {
      sourceElem: $(options.source),
      sourceName: options.source,
      validatorName: options.validatorName,
      eventType: options.eventType ? options.eventType : "submit"      
    }.extend(options || {});
  }
});

/******************************************************************************
 * Code to validate on server
 ******************************************************************************/
OpenFrameFormTag.ServerValidation = Class.create();
OpenFrameFormTag.ServerValidation.prototype=(new AjaxJspTag.Base()).extend({

  initialize: function(options) {    
    this.setOptions(options);
    this.attachBehaviors(this.options.sourceElem, this.options.eventType, this.actionElemClicked, this);
  },


  // Create bean with values to send to validation service
  //validateForm: function(sourceForm,validatorName,className,validationFormMessageMode,validationMessageFunction,errorPanelStyleId,indicator) {
  validateForm: function(sourceForm,validatorName,className) {     
       Element.hide($('errorsZone'));    
              
       // mirem que el bot s'hagi de validar o no, depenent de si te la variable bCancel posada al onclick
       if (!bCancel){

           // Forcem el pas de iFrame a camp dels TextArea rics de TinyMCE (si es que hi ha algu):
           try {
              if (tinyMCE){
                 tinyMCE.triggerSave()
              }
           } catch(err) {
              // Res a fer, nomes ignorar l'error
           }

    	   //alert("validateForm");
           DWREngine.setErrorHandler(errorHandling);
                                 
            // Obtain all components in form
              if (sourceForm) {
                  // form expected
                  list = sourceForm.elements;                
                   
                  if (list){
                        bean = new Object();
                        j=0;
                    for (i=0;i<list.length;i++){                    
                        var element = list[i];
                        
                        if (element.name) {                                                      
                              bean[element.name] = '""';
                        }                          
                    }
                }
              }
                                         
            DWRUtil.getValuesName(bean);
            var dataFromBrowser = new Object();
             dataFromBrowser['sourceForm'] = sourceForm;
                              
             
            webValidationService.getWebValidationResults(className,validatorName,bean,
             {
                 callback:function(dataFromServer) {                     
                     callbackValidateForm(dataFromServer,dataFromBrowser);
                 },
             timeout:5000
            });
                                       
            
            return false;
        } else {
            // si es tracta dun bot de tipus cancel fem submit sense validar
            sourceForm.submit();
        }
  },

  actionElemClicked: function(e) {  
     
        // DWR calling
       if (!validated) {
           this.validateForm(this.options.sourceElem,this.options.validatorName,this.options.className);   
           Event.stop(e);
          }          
  },
      
  setOptions: function(options) {

    this.options = {
      sourceElem: $(options.source),
      validatorName: $(options.validatorName),
      className: $(options.className), 
      eventType: options.eventType ? options.eventType : "submit"      
    }.extend(options || {});
  }
});

  
//Funcion para mostrar el tooltip
function   showTooltip(options) {
  
    this.setOptionsField(options);
    if (this.options.sourceElem) {
        var ele = this.options.sourceElem;    
        //alert('Elemen tooltip id'+ele.id+' tipus:'+ele.nodeType);
        ele.id = ele.name;
            
        var tooltipMessage = this.options.tooltipMessage;
        var tooltipTitleMessage = this.options.tooltipTitleMessage;
        var tooltipOptions = this.options.tooltipOptions;
        //alert('Tooltip message'+tooltipMessage);
        //alert('Element tooltip'+ele.name);
        ele.onmouseover  = function(event){
             domTT_activate(ele,event,'caption',tooltipTitleMessage,'content', tooltipMessage,'trail',true,'delay',0);
        }    
        
        if(domTT_tooltips.get(ele.name)!=undefined){
            domTT_update(ele.name,tooltipMessage,'content');
        }
        ele.onmouseout = function(event) { 
               domTT_close(ele.name);
        }        
     }    
  }
  
  function setOptionsField(options) {
 
    this.options = {
      sourceElem: $$(options.source)[0],
      eventType: options.eventType ? options.eventType : "mouseover"
    }.extend(options || {});
}