package es.bcn.gca.necn.business.model.bo.impl;

import java.util.List;

import net.opentrends.openframe.services.logging.LoggingService;
import net.opentrends.openframe.services.persistence.hibernate.HibernateDAO;
import es.bcn.gca.necn.common.model.ContextVO;


public class ContextBOImpl  implements es.bcn.gca.necn.common.model.bo.ContextBO {
	HibernateDAO hibernateDao;

	/** Accs al servei de traces. */
	LoggingService logService;

	public HibernateDAO getHibernateDao() {
		return hibernateDao;
	}

	public void setHibernateDao(HibernateDAO hibernateDao) {
		this.hibernateDao = hibernateDao;
	}

	/** Default constructor. */	
	/**
	 * 
	 */
	public ContextBOImpl() {
		super();
	}

	public void delete(ContextVO context) throws Exception {
		
		hibernateDao.delete(context);
	}

	public List findAll() {
		return hibernateDao.findAll(ContextVO.class);
	}

	public ContextVO get(ContextVO context) {
		context = (ContextVO) hibernateDao.get(ContextVO.class,
				context.getContextId());
		return context;
	}

	public ContextVO load(ContextVO context) {
		context = (ContextVO) hibernateDao.load(ContextVO.class,
				context.getContextId());
		return context;
	}

	public void save(ContextVO context) throws Exception {
		
		hibernateDao.save(context);
	}

	public void saveOrUpdate(ContextVO context) throws Exception {
		
		hibernateDao.saveOrUpdate(context);
	}

	public void update(ContextVO context) throws Exception {
		
		hibernateDao.update(context);
	}

	public LoggingService getLogService() {
		return logService;
	}

	public void setLogService(LoggingService logService) {
		this.logService = logService;
	}
  
}
