package es.bcn.gca.necn.business.model.bo.impl;

import java.util.List;

import net.opentrends.openframe.services.logging.LoggingService;
import net.opentrends.openframe.services.persistence.hibernate.HibernateDAO;
import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.PeticionsVO;


public class PeticionsBOImpl  implements es.bcn.gca.necn.common.model.bo.PeticionsBO {
	HibernateDAO hibernateDao;

	/** Accs al servei de traces. */
	LoggingService logService;

	public HibernateDAO getHibernateDao() {
		return hibernateDao;
	}

	public void setHibernateDao(HibernateDAO hibernateDao) {
		this.hibernateDao = hibernateDao;
	}

	/** Default constructor. */	
	/**
	 * 
	 */
	public PeticionsBOImpl() {
		super();
	}

	public void delete(PeticionsVO peticions) throws Exception {
		
		hibernateDao.delete(peticions);
	}

	public List findAll() {
		return hibernateDao.findAll(PeticionsVO.class);
	}

	public PeticionsVO get(PeticionsVO peticions) {
		peticions = (PeticionsVO) hibernateDao.get(PeticionsVO.class,
				peticions.getPetId());
		return peticions;
	}

	public PeticionsVO load(PeticionsVO peticions) {
		peticions = (PeticionsVO) hibernateDao.load(PeticionsVO.class,
				peticions.getPetId());
		return peticions;
	}

	public void save(PeticionsVO peticions) throws Exception {
		
		hibernateDao.save(peticions);
	}

	public void saveOrUpdate(PeticionsVO peticions) throws Exception {
		
		hibernateDao.saveOrUpdate(peticions);
	}

	public void update(PeticionsVO peticions) throws Exception {
	
		hibernateDao.update(peticions);
		
	}
	
	/*public void addToPaquet(PeticionsVO peticions, PaquetsVO paquets) throws Exception {
		
		
		peticions = (PeticionsVO) hibernateDao.load(PeticionsVO.class,
				peticions.getPetId());
		
		paquets = (PaquetsVO) hibernateDao.load(PaquetsVO.class, 
				paquets.getPaqId());
		
		peticions.addToPaquet(paquets);
		
	}*/

	public LoggingService getLogService() {
		return logService;
	}

	public void setLogService(LoggingService logService) {
		this.logService = logService;
	}
  
}
