package es.bcn.gca.necn.business.model.bo.impl;

import java.util.List;

import net.opentrends.openframe.services.logging.LoggingService;
import net.opentrends.openframe.services.persistence.hibernate.HibernateDAO;
import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.PeticionsVO;
import es.bcn.gca.necn.common.model.ProductesVO;


public class ProductesBOImpl  implements es.bcn.gca.necn.common.model.bo.ProductesBO {
	HibernateDAO hibernateDao;

	/** Accs al servei de traces. */
	LoggingService logService;

	public HibernateDAO getHibernateDao() {
		return hibernateDao;
	}

	public void setHibernateDao(HibernateDAO hibernateDao) {
		this.hibernateDao = hibernateDao;
	}

	/** Default constructor. */	
	/**
	 * 
	 */
	public ProductesBOImpl() {
		super();
	}

	public void delete(ProductesVO productes) throws Exception {
		
		hibernateDao.delete(productes);
	}

	public List findAll() {
		return hibernateDao.findAll(ProductesVO.class);
	}

	public ProductesVO get(ProductesVO productes) {
		productes = (ProductesVO) hibernateDao.get(ProductesVO.class,
				productes.getProdId());
		return productes;
	}

	public ProductesVO load(ProductesVO productes) {
		productes = (ProductesVO) hibernateDao.load(ProductesVO.class,
				productes.getProdId());
		return productes;
	}

	public void save(ProductesVO productes) throws Exception {
		
		hibernateDao.save(productes);
	}

	public void saveOrUpdate(ProductesVO productes) throws Exception {
		
		hibernateDao.saveOrUpdate(productes);
	}

	public void update(ProductesVO productes) throws Exception {
		
		hibernateDao.update(productes);
	}

	public LoggingService getLogService() {
		return logService;
	}
	
	public void setLogService(LoggingService logService) {
		this.logService = logService;
	}
  
}
