package es.bcn.gca.necn.web.pojo;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.ProductesVO;


public class PeticionsTO  implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	private String petId;

	private ProductesVO productes;
	
	private String producte;

	private String petCreador;

	private String petPeticionari;

	private Date petDataCreacio;

	private String petEstat;

	private Date petDataEstat;

	private String petTiquet;

	private boolean lower18;

	private String petObservacions;

	private Set paquets = new HashSet(0);

	public PeticionsTO() {
	}

	public PeticionsTO(String petId, ProductesVO productes, String petEstat,
			String petCreador, String petPeticionari, Date petDataCreacio,
			Date petDataEstat, String petTiquet) {
		this.petId = petId;
		this.productes = productes;
		this.petCreador = petCreador;
		this.petPeticionari = petPeticionari;
		this.petDataCreacio = petDataCreacio;
		this.petEstat = petEstat;
		this.petDataEstat = petDataEstat;
		this.petTiquet = petTiquet;

	}

	public PeticionsTO(String petId,ProductesVO productes, String petEstat,
			String petCreador, String petPeticionari, Date petDataCreacio,
			Date petDataEstat, String petTiquet,
			boolean lower18, String petObservacions, Set paquets, String producte) {
		this.petId = petId;
		this.productes = productes;
		this.petCreador = petCreador;
		this.petPeticionari = petPeticionari;
		this.petDataCreacio = petDataCreacio;
		this.petDataEstat = petDataEstat;
		this.petTiquet = petTiquet;
		this.petEstat = petEstat;
		this.lower18 = lower18;
		this.petObservacions = petObservacions;
		this.paquets = paquets;
		this.producte = producte;
	}

	public String getPetId() {
		return this.petId;
	}

	public void setPetId(String petId) {
		this.petId = petId;
	}

	public ProductesVO getProductes() {
		return this.productes;
	}

	public void setProductes(ProductesVO productes) {
		this.productes = productes;
	}
	
	public String getPetEstat() {
		return this.petEstat;
	}

	public void setPetEstat(String petEstat) {
		this.petEstat = petEstat;
	}
	
	public String getPetCreador() {
		return this.petCreador;
	}

	public void setPetCreador(String petCreador) {
		this.petCreador = petCreador;
	}

	public String getPetPeticionari() {
		return this.petPeticionari;
	}

	public void setPetPeticionari(String petPeticionari) {
		this.petPeticionari = petPeticionari;
	}

	public Date getPetDataCreacio() {
		return this.petDataCreacio;
	}

	public void setPetDataCreacio(Date petDataCreacio) {
		this.petDataCreacio = petDataCreacio;
	}

	public Date getPetDataEstat() {
		return this.petDataEstat;
	}

	public void setPetDataEstat(Date petDataEstat) {
		this.petDataEstat = petDataEstat;
	}

	public String getPetTiquet() {
		return this.petTiquet;
	}

	public void setPetTiquet(String petTiquet) {
		this.petTiquet = petTiquet;
	}

	public boolean getLower18() {
        return this.lower18;
    }
    
    public void setLower18(boolean lower18) {
        this.lower18 = lower18;
    }

	public String getPetObservacions() {
		return this.petObservacions;
	}

	public void setPetObservacions(String petObservacions) {
		this.petObservacions = petObservacions;
	}

	public Set getPaquets() {
		return this.paquets;
	}

	public void setPaquets(Set paquets) {
		this.paquets = paquets;
	}
	public String getProducte() {
		return this.producte;
	}

	public void setProducte(String producte) {
		this.producte = producte;
	}
	
	public void addToPaquet(PaquetsVO paquet) {
        this.getPaquets().add(paquet);
        paquet.getPeticions().add(this);
	}

	public void removeFromPaquet(PaquetsVO paquet) {
		this.getPaquets().remove(paquet);
		paquet.getPeticions().remove(this);
	}
}
