package es.bcn.gca.necn.web.pojo;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;


public class ProductesTO  implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	
	private String prodId;

	private String prodDesc;

	private String prodEstat;
	
	private Date prodDataCreacio;

	private String prodMotiuRebuig;

	private Date prodDataBaixa;

	private String prodObservacions;

	private Set peticions = new HashSet(0);

	public ProductesTO() {
	}

	public ProductesTO(String prodId) {
		this.prodId = prodId;

	}
	
	public ProductesTO(String prodId, String prodDesc, String prodEstat,
			Date prodDataCreacio) {
		this.prodId = prodId;
		this.prodDesc = prodDesc;
		this.prodEstat = prodEstat;
		this.prodDataCreacio = prodDataCreacio;
	}

	public ProductesTO(String prodId, String prodDesc, String prodEstat,
			Date prodDataCreacio, String prodMotiuRebuig, Date prodDataBaixa,
			String prodObservacions, Set peticions) {
		this.prodId = prodId;
		this.prodDesc = prodDesc;
		this.prodEstat = prodEstat;
		this.prodDataCreacio = prodDataCreacio;
		this.prodMotiuRebuig = prodMotiuRebuig;
		this.prodDataBaixa = prodDataBaixa;
		this.prodObservacions = prodObservacions;
		this.peticions = peticions;
	}

	public String getProdId() {
		return this.prodId;
	}

	public void setProdId(String prodId) {
		this.prodId = prodId;
	}

	public String getProdDesc() {
		return this.prodDesc;
	}

	public void setProdDesc(String prodDesc) {
		this.prodDesc = prodDesc;
	}

	public Date getProdDataCreacio() {
		return this.prodDataCreacio;
	}

	public void setProdDataCreacio(Date prodDataCreacio) {
		this.prodDataCreacio = prodDataCreacio;
	}

	public String getProdMotiuRebuig() {
		return this.prodMotiuRebuig;
	}

	public void setProdMotiuRebuig(String prodMotiuRebuig) {
		this.prodMotiuRebuig = prodMotiuRebuig;
	}

	public Date getProdDataBaixa() {
		return this.prodDataBaixa;
	}

	public void setProdDataBaixa(Date prodDataBaixa) {
		this.prodDataBaixa = prodDataBaixa;
	}

	public String getProdObservacions() {
		return this.prodObservacions;
	}

	public void setProdObservacions(String prodObservacions) {
		this.prodObservacions = prodObservacions;
	}

	public Set getPeticions() {
		return this.peticions;
	}

	public void setPeticions(Set peticions) {
		this.peticions = peticions;
	}
}
