<%@ include file="/WEB-INF/jsp/includes/fwkTagLibsPg.jsp" %>
<c:url value="/fwk/img/notice/bcn/warning.gif" var="warningIcon" />
<c:set var="warningAlt" value="Warning" />
<c:url value="/fwk/img/notice/bcn/ok.png" var="infoIcon" />
<c:set var="infoAlt" value="Info" />

<!-- BEGIN errors -->
<div class="openFrame_error_zone" id="errorsZone" style="display:none">
	<img src="${warningIcon}" alt="${warningAlt}" />
	<strong>
		<span style="margin-left: 5px">
			<fmt:message key="error.form.errorsFound"/>
		</span>
		<br/>
		<span style="margin-left: 23px">
			<fmt:message key="error.form.correctErrors"/>
		</span>
	</strong>
	<br/>
	<ul id="errorList">
		<li></li> 
	</ul>
</div>
<script type="text/javascript">
var errorDetails_warning = false;  
var errorDetails_error = false;
function showDivErrorDetails() {
	if (errorDetails_warning) {
		showEL("errorDetails_warning");
	} else if (errorDetails_error) {
		showEL('errorDetails_error');
	} else {
		return;
	}
}
  
function showEL(el) {
	var ele = $(el);
	if (ele) {
		if(ele.style.display == 'none'){
			ele.style.display='';
		} else {
			ele.style.display='none';
		}
	}
	return;
}
</script>

<c:set var="errorServerMsg" value='${requestScope["org.apache.struts.action.ERROR"]}'/>
<c:set var="errorValidationServer" value='${requestScope["net.opentrends.openframe.services.validation.ERRORS"]}'/>
<c:set var="notificationMsg" value='${requestScope["org.apache.struts.action.ACTION_MESSAGE"]}'/>

<c:if test="${notificationMsg != null}">
	<div class="openFrame_notification_zone" id="serverNotificationZone">
		<img src="${infoIcon}" alt="${infoAlt}" />
		<html:messages id="msg_noti" name="org.apache.struts.action.ACTION_MESSAGE">
			<b><c:out value="${msg_noti}" escapeXml="false"/></b>
		</html:messages>
	</div>
</c:if>

<div class="openFrame_error_zone" id="serverValidationErrorsZone" style="display: none;">
	<strong>
		<img src="${warningIcon}" alt="${warningAlt}" />
		<span style="margin-left: 5px">
			<fmt:message key="error.form.errorsFound"/><c:out value="${errorValidationServer.errorCount}"/>
		</span>
		<br/>
		<span style="margin-left: 23px">
			<fmt:message key="error.form.correctErrors"/>
		</span>
	</strong>
	<br/>
	<ul id="errorList">
		<c:forEach items="${errorValidationServer.allErrors}" var="validationError">							 							
			<li><c:out value="${validationError.defaultMessage}"/></li>
		</c:forEach>					
	</ul>
</div>
<c:if test="${errorValidationServer != null}">
	<script type="text/javascript"> 
		showEL("serverValidationErrorsZone"); 
	</script>
</c:if>

<div class="openFrame_error_zone" id="serverErrorsZone" style="display:none">
	<strong>
		<img src="${warningIcon}" alt="${warningAlt}" />
		<span id="globalErrorMsg" style="margin-left: 5px">
			<html:messages id="msg_err" name="org.apache.struts.action.ERROR" property="org.apache.struts.action.ERROR">
				<b><c:out value="${msg_err}" escapeXml="false"/></b>
			</html:messages>
		</span>
	</strong>
	
	<c:set var="msg_detail" value=""/>
	<html:messages id="msg_detail_warn" name="org.apache.struts.action.ERROR" property="net.opentrends.openframe.services.exceptions.Level.WARNING">
		<c:set var="div_styleClass" value="errorDetails_warning" />
		<c:set var="msg_color" value="#00CC00" />
		<c:set var="msg_detail" value="${msg_detail_warn}"/>
		<script type="text/javascript">errorDetails_warning=true;</script>
	</html:messages>
	<html:messages id="msg_detail_err" name="org.apache.struts.action.ERROR" property="net.opentrends.openframe.services.exceptions.Level.ERROR">
		<c:set var="div_styleClass" value="errorDetails_error" />
		<c:set var="msg_color" value="#FF0000" />
		<c:set var="msg_detail" value="${msg_detail_err}" />
		<script type="text/javascript">errorDetails_error=true;</script>
	</html:messages>
	
	<c:if test="${not empty msg_detail}">
		<span class="link-boton">
			[ <a href="javascript:showDivErrorDetails()"><fmt:message key="jsp.includes.see_error_details"/></a> ]
			&nbsp;
			[ <a href="javascript:showEL('stackTrace')"><fmt:message key="jsp.includes.see_stack_trace"/></a>]
		</span>
		<div id="${div_styleClass}" style="display: none">
			<font color="${msg_color}"><c:out value="${msg_detail}" escapeXml="false"/></font>
		</div>
		<div id="stackTrace" style="display: none">
			<html:messages id="msg_stktrace" name="org.apache.struts.action.ERROR" property="net.opentrends.openframe.services.exceptions.STACKTRACE">										
				<br /><pre><c:out value="${msg_stktrace}" escapeXml="false"/></pre>
			</html:messages>	
		</div>
	</c:if>
	
</div>
<c:if test="${errorServerMsg != null}">
	<script type="text/javascript"> 
		showEL("serverErrorsZone"); 
	</script>
</c:if>
<!-- END errors -->
