<%@ page contentType="text/html;charset=ISO-8859-15" language="java" pageEncoding="ISO-8859-15"%>
<%@ page import="javax.servlet.http.Cookie" %>
<%@ page import="net.sf.acegisecurity.ui.rememberme.TokenBasedRememberMeServices" %>
<%
	response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	response.setHeader("Pragma","no-cache"); //HTTP 1.0
	response.setDateHeader("Expires", 0); //prevents caching at the proxy server
	response.setHeader("refresh",""+(new Integer(60+session.getMaxInactiveInterval()).intValue())+";url="+request.getContextPath()+"/pagetimeout.do"); //on session timeotu redirect to logout page
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ include file="/WEB-INF/jsp/includes/fwkTagLibsPg.jsp" %>
<fmt:setBundle basename="i18n/applicationResources" scope="request" />
<tiles:importAttribute scope="request"/>
<html>
	<head>
		<title><fmt:message key="site.applicationName"/></title>
		<link rel="stylesheet" href="<c:url value="/fwk/styles/bcn/openFrame.css" />" type="text/css"/>
		<script type="text/javascript">
			var contextPath = '<%=request.getContextPath()%>';
		</script>
		<fwk:configuration styleId="defaultConfiguration" />
	</head>
	<body>
		<div id="openFrame_header">
			<tiles:insert attribute="header" />
		</div>
		<div id="openFrame_body">
			<div id="openFrame_main_content_noMenu">
				<tiles:insert attribute="useCaseTitle" />
				<tiles:insert attribute="errors" />								
				<tiles:insert attribute="body" />
			</div>
		</div>
		<div id="openFrame_footer">
			<tiles:insert attribute="footer" />
		</div>
	</body>
</html>
<c:if test="${not empty sessionInvalidate && sessionInvalidate == 'true'}">
<%
	session.invalidate();
	Cookie terminate = new Cookie(TokenBasedRememberMeServices.ACEGI_SECURITY_HASHED_REMEMBER_ME_COOKIE_KEY, null);
	terminate.setMaxAge(0);
	response.addCookie(terminate);
%>
</c:if>
